﻿// Fill out your copyright notice in the Description page of Project Settings.


#include "BTTask_AttackPlayer.h"

#include "EndlessVendetta/AI/AI_EnemyController.h"
#include "BehaviorTree/BlackboardComponent.h"
#include "EndlessVendetta/AI/EnemyCharacter.h"

UBTTask_AttackPlayer::UBTTask_AttackPlayer(FObjectInitializer const& ObjectInitializer)
{
	NodeName = TEXT("Attack Player");
}

EBTNodeResult::Type UBTTask_AttackPlayer::ExecuteTask(UBehaviorTreeComponent& OwnerComp, uint8* NodeMemory)
{
	if (const AAI_EnemyController* const AIController = Cast<AAI_EnemyController>(OwnerComp.GetAIOwner()))
	{
		if (const UBlackboardComponent* const Blackboard = OwnerComp.GetBlackboardComponent())
		{
			FVector const Origin = AIController->GetPawn()->GetActorLocation();
			FVector const PlayerLocation = Blackboard->GetValueAsVector("TargetLocation");
			//DrawDebugLine(GetWorld(), Origin, PlayerLocation, FColor::Green, false, 1.f, 0, 1.f);

			if (AEnemyCharacter* const EnemyCharacter = Cast<AEnemyCharacter>(AIController->GetPawn()))
			{
				EnemyCharacter->SetFiring(true);

				FinishLatentTask(OwnerComp, EBTNodeResult::Succeeded);
				return EBTNodeResult::Succeeded;
			}
		}
	}
	return EBTNodeResult::Failed;
}
